eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
    & eval 'exec perl -S $0 $argv:q'
    if 0;

# -*- perl -*-
#
# $Id$

use lib "$ENV{ACE_ROOT}/bin";
use PerlACE::TestTarget;

$hmnodecount = 8;
$nmnodecount = 0;
$hostname = `hostname`;
chomp $hostname;
# extract name before first dot and use it
#$hostname =~ /(^.*?)\..*/;

#if ($1)
#{
#    $host = $1;
#}
#else
#{
    $host = $hostname;
#}

print "HOST=$host\n";

$ns_endpoint = "iiop://$hostname:45454";

print "$ns_endpoint\n";
#$ns_initref = "-ORBInitRef NameService=$ns_endpoint/NameService";
$ns_initref = "-ORBInitRef NameService=file://../node-1/ns.ior";
$debug = "-debug 3";
$common_args = "$ns_initref $debug";
$experiment = `cat /var/emulab/boot/nickname`;
chomp $experiment;
$experiment =~ /\.(.*)\./;
$experiment = $1;

@remote_hosts;
@targets;
@remote_hms;

$target_count = 4;

my $nsior = "ns.ior";
my $rmior = "rm.ior";
my $hmior = "hm-$host.ior";
my $hmutil = "hm-$host-util.dat";

my $ns = PerlACE::TestTarget::create_target (1) || die "creating Name_Service target failed\n";
my $rm = PerlACE::TestTarget::create_target (2) || die "creating ReplicationManager target failed\n";
my $hm = PerlACE::TestTarget::create_target (3) || die "creating HostMonitor target failed\n";

my $ns_iorfile = $ns->LocalFile ($nsior);
my $rm_iorfile = $rm->LocalFile ($rmior);
my $rm_hm_ior = $rm->LocalFile ($hmior);
my $hm_iorfile = $hm->LocalFile ($hmior);
my $hm_utilfile = $hm->LocalFile ($hmutil);

$ns->DeleteFile ($nsior);
$rm->DeleteFile ($rmior);
$hm->DeleteFile ($hmior);
$hm->DeleteFile ($hmutil);

$NS = $ns->CreateProcess ("$ENV{TAO_ROOT}/orbsvcs/Naming_Service/Naming_Service",
                          "-ORBEndpoint $ns_endpoint -o $nsior");

$RM = $rm->CreateProcess ("$ENV{TAO_ROOT}/orbsvcs/LWFT_Service/ReplicationManager",
                          "$common_args -use_ns -hm_ior file://$hmior -proc_id ReplicationManager-$host " .
                          "-role 0");

$HM = $hm->CreateProcess ("$ENV{TAO_ROOT}/orbsvcs/LWFT_Service/HostMonitor",
                          "$ns_initref -load_mon_freq 10 -rm_update_freq 1 -ior_file $hmior -util_file $hmutil -rm_name ReplicationManager");

sub start_remote_hm
{
    my $remotenode = "node-$_[0]";
    my $remhm_ior = "hm-$remotenode.flare-f6.f6.isislab.vanderbilt.edu.ior";
    my $remhm = PerlACE::TestTarget::create_target ($target_count++) || die "creating Name_Service target failed\n";
    my $remote_ior = $remhm->LocalFile ("../$remotenode/$remhm_ior");
    my $util_file = $remhm->LocalFile ("../$remotenode/$remotenode-util.dat");

    $remhm->DeleteFile ("../$remotenode/$remhm_ior");

    $REMHM = $remhm->CreateProcess ("/usr/bin/ssh",
                                    "$remotenode.$experiment.f6.isislab.vanderbilt.edu " .
                                    "\". flare.sh && cd $ENV{EXP_ROOT}/$remotenode " .
                                    "&& $ENV{TAO_ROOT}/orbsvcs/LWFT_Service/HostMonitor -logging 1 " .
                                    "-load_mon_freq 10 -rm_update_freq 1 -ior_file $remhm_ior " .
                                    "-util_file util-$remotenode.dat -rm_name ReplicationManager " .
                                    "$ns_initref -port_range_begin 7000\"");

    print "start remote HostMonitor on node $remotenode ...\n";

    $REMHM->Spawn ();
 
    push (@remote_hosts, $remotenode);
    push (@targets, $remhm);
    push (@remote_hms, $REMHM);
}

sub kill_processes
{
    $hm_status = $HM->Kill ();
    $HM->Wait ();
    $hm->DeleteFile ($hmior);
    $hm->DeleteFile ($hmutil);

    print "stopped HostMonitor.\n";
    
    for ($i = 0; $i < @remote_hosts; ++$i)
    {
        print "stop HostMonitor on node $remote_hosts[$i] ...\n";

        $remote_hms[$i]->Kill ();
        $targets[$i]->DeleteFile ("../$remote_hosts[$i]/hm-$remote_hosts[$i].ior");
        $targets[$i]->DeleteFile ("../$remote_hosts[$i]/util-$remote_hosts[$i].dat");
    }

    $rm_status = $RM->Kill ();
    $RM->Wait ();
    $rm->DeleteFile ($rmior);

    print "stopped ReplicationManager.\n";

    $ns_status = $NS->Kill ();
    $NS->Wait ();
    $ns->DeleteFile ($nsior);

    print "stopped Name_Service.\n";
}

print "start Name_Service ...\n";

$ns_status = $NS->Spawn ();

if ($ns->WaitForFileTimed ($nsior,
                           $ns->ProcessStartWaitInterval ()) == -1) {
    print STDERR "ERROR: Name_Service did not create file <$nsior>\n";
    $NS->Kill (); $NS->TimedWait (1);
    exit 1;
}

print "start ReplicationManager ...\n";

$rm_status = $RM->Spawn ();

if ($rm->WaitForFileTimed ($rmior,
                           $rm->ProcessStartWaitInterval ()) == -1) {
    print STDERR "ERROR: Name_Service did not create file <$nsior>\n";
    $RM->Kill (); $RM->TimedWait (1);
    exit 1;
}

sleep 2;

print "start HostMonitor ...\n";

$hm_status = $HM->Spawn ();

if ($hm->WaitForFileTimed ($hmior,
                           $hm->ProcessStartWaitInterval ()) == -1) {
    print STDERR "ERROR: HostMonitor did not create file <$hmior>\n";
    $HM->Kill (); $HM->TimedWait (1);
    exit 1;
}

for ($count = 2; $count < 2 + $hmnodecount; ++$count)
{
    start_remote_hm ($count);
}
 
$input = <>;

kill_processes ();
