eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
    & eval 'exec perl -S $0 $argv:q'
    if 0;

# -*- perl -*-
#
# $Id$

use lib "$ENV{ACE_ROOT}/bin";
use PerlACE::TestTarget;

$target_count = 0;

$experiment = `cat /var/emulab/boot/nickname`;
chomp $experiment;
$experiment =~ /\.(.*)\./;
$experiment = $1;

@targets = ();
@servers = ();
@iors = ();

$app_counter = 0;

$ns_initref = "-ORBInitRef NameService=file://../node-1/ns.ior";

sub kill_server
{
    my $host = "$_[0]";

    my $wk = PerlACE::TestTarget::create_target (++$app_counter) || die "creating Worker target failed\n";

    $WK = $wk->CreateProcess ("/usr/bin/ssh",
                              "$host " .
                              "\"killall server\"");

    print "kill Workers on $host $appid $role ...\n";

    my $wk_status = $WK->Spawn ();

    $WK->Wait ();
    $WK->Kill ();
}

sub start_server
{
    my $appid = $_[0];
    my $host = "node-$_[1]";
    my $role = $_[2];
    my $ior = "../$host/$appid.ior";
    my $hmior = "../$host/hm-$host.ior";
    my $iterations;

    if ($role == 1)
    {
        $iterations = 110;        
    }
    else
    {
        $iterations = 0;
    }

    my $wk = PerlACE::TestTarget::create_target (++$app_counter) || die "creating Worker target failed\n";

    $WK = $wk->CreateProcess ("/usr/bin/ssh",
                              "$host.$experiment.f6.isislab.vanderbilt.edu " .
                              "\". ftciao.sh && cd $ENV{EXP_ROOT}/object-failover/$host && " .
                              "$ENV{TAO_ROOT}/orbsvcs/examples/FaultTolerance/FLARe/Worker/server " .
                              "$ns_initref -hm_ior file://$hmior " . 
                              "-app_id $appid -role $role -load 10 -proc_id $host-$appid-$role " .
                              "-p $ior -i $iterations $debug -ORBEndpoint iiop://$host\"");

    print "start Worker $host $appid $role ...\n";

    my $wk_status = $WK->Spawn ();

    sleep 3;

#    if ($role == 1)
#    {
#        if ($wk->WaitForFileTimed ($ior,
#                                   10) == -1) {
#            print STDERR "ERROR: Worker did not create file <$ior>\n";
#            kill_server ($host);
#            exit 1;
#        }
#    }

    push (@targets, $wk);
    push (@servers, $WK);
    push (@iors, $ior);
}

sub start_client
{
    my $appid = $_[0];
    my $host = "node-$_[1]";
    my $ior = "../node-2/$appid.ior";
    my $iterations = 120;
    my $period = 200;
    my $exectime = 180;
    my $log_start = 100;
    my $prefix = "$_[2]";

    my $wk = PerlACE::TestTarget::create_target (++$app_counter) || die "creating Worker target failed\n";

    my $cparam = "$ns_initref -l -s $appid -p file://$ior " .
        "-r $period -e $exectime -i $iterations -f $prefix -n $log_start $debug";

    $WK = $wk->CreateProcess ("/usr/bin/ssh",
                              "$host.$experiment.f6.isislab.vanderbilt.edu " .
                              "\". ftciao.sh && cd $ENV{EXP_ROOT}/object-failover/$host && " .
                              "$ENV{TAO_ROOT}/orbsvcs/examples/FaultTolerance/FLARe/Worker/client " .
                              "$cparam\"");

    print "start client $host $appid ...\n";

    my $wk_status = $WK->Spawn ();

    push @clients, $WK;
}

$testname = "90percent";

for my $i (1 .. 5)
{
    start_server ("Alpha", 2, 1);
    start_server ("Alpha", 3, 2);
    start_client ("Alpha", 4, "$testname-$i");

    foreach my $client (@clients)
    {
        $client->Wait ();
        $client->Kill ();
        print "client finished.\n";
    }

    for ($i =0; $i < @servers; ++$i)
    {
        $servers[$i]->Wait ();
        $servers[$i]->Kill ();
        
        $targets[$i]->DeleteFile ($iors[$i]);

        print "Worker $ior finished.\n";
    }

    @servers = ();
    @targets = ();
    @clients = ();
}
