#!/bin/bash
export NSPORT=45455
export NSHOST=`hostname`
HOST=`hostname | awk -F '.' '{ printf "%s", $1}'`
export EXPERIMENT=`cat /var/emulab/boot/nickname | awk -F '.' '{ printf "%s", $2 }'`
ROLE=1

echo starting NameService ...
$TAO_ROOT/orbsvcs/Naming_Service/Naming_Service -ORBEndpoint iiop://$NSHOST:$NSPORT -o ns.ior &

sleep 1

echo starting ReplicationManager...
$TAO_ROOT/orbsvcs/LWFT_Service/ReplicationManager \
  -ORBInitRef NameService=corbaloc:iiop:$NSHOST:$NSPORT/NameService \
  -use_ns \
  -hm_ior file://hm-$HOST.ior \
  -proc_id ReplicationManager-$HOST \
  -role $ROLE \
  -debug 5 \
  -use_dds &

sleep 2

echo starting local HostMonitor...
$TAO_ROOT/orbsvcs/LWFT_Service/HostMonitor -load_mon_freq 10 -rm_update_freq 1 -ior_file hm-$HOST.ior -util_file util-$HOST.dat -rm_name ReplicationManager -ORBInitRef NameService=corbaloc:iiop:$NSHOST:$NSPORT/NameService &

echo starting remote HostMonitors...
for REMOTEHOST in node-2 node-3 node-4; do 
  ssh $REMOTEHOST.$EXPERIMENT.f6.isislab.vanderbilt.edu ". ftciao.sh && cd $EXP_ROOT/plan/$REMOTEHOST && $TAO_ROOT/orbsvcs/LWFT_Service/HostMonitor -load_mon_freq 10 -rm_update_freq 1 -ior_file hm-$REMOTEHOST.ior -util_file util-$REMOTEHOST.dat -rm_name ReplicationManager -ORBInitRef NameService=corbaloc:iiop:$NSHOST:$NSPORT/NameService -port_range_begin 7000 -debug 5" &
done

echo starting ExecutionManager ...
$DANCE_ROOT/bin/dance_execution_manager -ORBInitRef NameService=corbaloc:iiop:$NSHOST:$NSPORT/NameService -eEM-internal.ior --domain-nc corbaloc:rir:/NameService &

sleep 2

export DANCE_TRACE_ENABLE=5

echo starting FaultCorrelationManager ...
$DANCE_ROOT/bin/fcm -ORBInitRef NameService=corbaloc:iiop:$NSHOST:$NSPORT/NameService --rep-mgr corbaname:rir:/NameService#ReplicationManager --exec-mgr file://EM-internal.ior --ior-file EM.ior&