#!/bin/bash
export NSPORT=45455
export NSHOST=`hostname`
HOST=`hostname | awk -F '.' '{ printf "%s", $1}'`
export EXPERIMENT=`cat /var/emulab/boot/nickname | awk -F '.' '{ printf "%s", $2 }'`
ROLE=1

echo starting NameService ...
$TAO_ROOT/orbsvcs/Naming_Service/Naming_Service -ORBEndpoint iiop://$NSHOST:$NSPORT -o ns.ior &

sleep 1

echo starting ReplicationManager...
valgrind $TAO_ROOT/orbsvcs/LWFT_Service/ReplicationManager \
  -ORBInitRef NameService=corbaloc:iiop:$NSHOST:$NSPORT/NameService \
  -use_ns \
  -hm_ior file://hm-$HOST.ior \
  -proc_id ReplicationManager-$HOST \
  -role $ROLE \
  -debug 3